#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define BUF_SIZE 200
#define BATCH 10

struct student {
	char *firstname;
	char *lastname;
	int aem;
};

typedef struct student studentT;
void clean(studentT *data, int howmany);

int readstudents(studentT **data) {
	char buffer[BUF_SIZE], formatstr[20];
	int count = 0;
	int size = 0;
	studentT *temp;
	
	*data = (studentT *)malloc(BATCH*sizeof(studentT));
	if (*data == NULL) {
		printf("Malloc problem\n");
		exit(1);
	}
	size = BATCH;
	
	sprintf(formatstr, "%%%ds", BUF_SIZE-1);
	while(1) {
		printf("Student %d\n", count);
		if (count >= size) {
			temp = (studentT *)realloc(*data, (size+BATCH)*sizeof(studentT));
			
			if (temp == NULL) {
				printf("Malloc problem\n");
				clean(*data, size);
				exit(1);
			}
			else {
				*data = temp;
			}
			
			size = size+BATCH;
		}
		
		printf("Enter AEM: ");
		scanf("%d", &((*data)[count].aem));
		
		if ((*data)[count].aem == -1) {
			return(count);
		}
			
		printf("Enter firstname: ");
		scanf(formatstr, buffer);
		(*data)[count].firstname = strdup(buffer);
		if ((*data)[count].firstname == NULL) {
			printf("Mem alloc problem\n");
			clean(*data, count);
			exit(1);
		}
		
		printf("Enter lastname: ");
		scanf(formatstr, buffer);
		(*data)[count].lastname = strdup(buffer);
		if ((*data)[count].lastname == NULL) {
			free((*data)[count].firstname);
			printf("Mem alloc problem\n");
			clean(*data, count);
			exit(1);
		}
		count++;
	}
	return(count);
}

void clean(studentT *data, int howmany) {
	int i;
	
	for (i = 0; i < howmany; i++) {
		free(data[i].firstname);
		free(data[i].lastname);		
	}
	free(data);

}

void print_students(studentT *data, int howmany) {
	int i;
	
	for (i = 0; i < howmany; i++) {
		printf("Student %d: First: %s, Last: %s, AEM: %d\n", 
				i, data[i].firstname, data[i].lastname, data[i].aem);
	}
}

int main(int argc, char *argv[]) {
	studentT *database;
	int howmany;
	
	howmany = readstudents(&database);
	print_students(database, howmany);
	clean(database, howmany);
	return(0);
}
