#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define BUF_SIZE	200

struct student {
	char *firstname;
	char *lastname;
	int aem;
};

typedef struct student studentT;

/* Now we will allocate the "array" within
 * readstudents. Notice the type of "data" 
 * and how readstudents is called by main.
 * Also notice dereferencing of data in 
 * readstudents */
int readstudents(studentT **data, int howmany) {
	char buffer[BUF_SIZE], formatstr[20];
	int count;
	
	/* Dynamically allocate memory for the database "data" */
	*data = (studentT *)malloc(howmany*sizeof(studentT));
	if (*data == NULL) {
		printf("Malloc problem\n");
		exit(1);
	}

	
	sprintf(formatstr, "%%%ds", BUF_SIZE-1);
	for (count = 0; count < howmany; count++) {
		printf("Student %d\n", count);
		
		printf("Enter firstname: ");
		scanf(formatstr, buffer);
		(*data)[count].firstname = strdup(buffer);
		if ((*data)[count].firstname == NULL) {
			printf("Mem alloc problem\n");
			return(count);
		}
		
		printf("Enter lastname: ");
		scanf(formatstr, buffer);
		(*data)[count].lastname = strdup(buffer);
		if ((*data)[count].lastname == NULL) {
			free((*data)[count].firstname);
			printf("Mem alloc problem\n");
			return(count);
		}
		
		printf("Enter AEM: ");
		scanf("%d", &((*data)[count].aem));
	}
	return(count);
}

void clean(studentT *data, int howmany) {
	int i;
	
	for (i = 0; i < howmany; i++) {
		free(data[i].firstname);
		free(data[i].lastname);		
	}
	/* Don't forget to release memory for the 
	 * data "array" AFTER you release the memory 
	 * pointed-to by pointers within the "array" */
	free(data);

}

void print_students(studentT *data, int howmany) {
	int i;
	
	for (i = 0; i < howmany; i++) {
		printf("Student %d: First: %s, Last: %s, AEM: %d\n", 
				i, data[i].firstname, data[i].lastname, data[i].aem);
	}
}

int main(int argc, char *argv[]) {
	studentT *database;
	int howmany, howmany_read;
	
	printf("Howmany students? ");
	scanf("%d", &howmany);
		
	/* Observe how the function is called, 
	 * especially the 1st parameter */
	howmany_read = readstudents(&database, howmany);
	if (howmany != howmany_read) {
		printf("Exiting\n");
		clean(database, howmany_read);
		exit(1);
	}
	
	print_students(database, howmany);
	clean(database, howmany);
	return(0);
}
